#include <stdio.h>
#include <stdint.h>
#include <omp.h>

int
main(void)
{
    volatile uint64_t token = 0;

    #pragma omp parallel default(none) shared(token)
    {
        uint64_t id = omp_get_thread_num();

        while (token != id)
        {
            // Required by gcc version <= 4.8.2
            #pragma omp flush(token)
            ;
        }

        printf("[%lu]\tI have the token!\n", id);

        #pragma omp atomic
        token++;
    }

    return 0;
}
