#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <omp.h>
int
main(void)
{
    volatile uint64_t token = 0;

    #pragma omp parallel default(none) shared(token,lock)
    {
        uint64_t  id   = omp_get_thread_num();
        bool      done = false;

        do {
            #pragma omp critical
            {
                if (token == id) {
                    printf("[%lu]\tI have the token!\n", id);
                    token += 1;
                    done = true;
                }
            }
        } while (!done);
    }

    return 0;
}
